EDIT - bug #7331

AdvancedBeanlnitializer fails to initialize properties of preinitialized beans in the graph in very
special situations

03/27/2018 01:50 PM - Andreas Kohlbecker
Target version: Unassigned CDM tickets

Severity: normal Found in Version: Release 5.0
Description

In the RegistrationWorkingSetService.loadWorkingSetByReferencelD(Integer referencelD) a RegistrationWorkingSet is loaded with
the following code:

List<String> REGISTRATION_INIT_STRATEGY = Arrays.asList(new String []{
"blockedBy",
// typeDesignation
"typeDesignations.typeStatus",
"typeDesignations.typifiedNames.typeDesignations", // important !!
"typeDesignations.typeSpecimen",
"typeDesignations.typeName.S$",
"typeDesignations.citation",
"typeDesignations.citation.authorship.$",
// name
"name.S$",
"name.nomenclaturalReference.authorship.$",
"name.nomenclaturalReference.inReference",
"name.rank",
"name.homotypicalGroup.typifiedNames",
"name.status.type",
"name.typeDesignations", // important !!"
// institution
"institution",
}

)i

Reference reference = repo.getReferenceService () .find(referencelD);

Pager<Registration> pager = repo.getRegistrationService () .page (Optional.of (reference), null, null,
null, REGISTRATION_INIT_STRATEGY) ;

return new RegistrationWorkingSet (makeDTOs (pager.getRecords()));

This usually works, but with a specific data set the pager contains Registrations where authorship
properties of the nomenclaturalReferences are not initialized even if the AdvancedBeanlnitializer apparently is doing the initialization
properly (also confirmed by debugging):

[eu.et.cd.pe.da.in.AdvancedBeanInitializer] - processing /name.nomenclaturalReference
[eu.et.cd.pe.da.in.AdvancedBeanInitializer] - invoke initialization on /name.nomenclaturalReferen
ce beans of class TaxonName
[eu.et.cd.pe.da.in.AdvancedBeanInitializer] - bulk load /name.nomenclaturalReference
[eu.et.cd.pe.da.in.AdvancedBeanInitializer] - bulk load /name.nomenclaturalReference - DONE
[eu.et.cd.pe.da.in.AdvancedBeanInitializer] - processing /name.nomenclaturalReference.authorship
[eu.et.cd.pe.da.in.AdvancedBeanInitializer] - invoke initialization on /name.nomenclaturalReferen

ce.authorship beans of class Reference

[eu.et.cd.pe.da.in.AdvancedBeanInitializer] - bulk load /name.nomenclaturalReference.authorship
[eu.et.cd.pe.da.in.AdvancedBeanInitializer] - bulk load beans of class TeamOrPersonBase
[eu.et.cd.pe.da.in.AdvancedBeanInitializer] - SELECT c FROM TeamOrPersonBase as ¢ WHERE c.id IN
(:idSet)

[eu.et.cd.pe.da.in.AdvancedBeanInitializer] - initialize bulk loaded beans of class TeamOrPersonBa
se: [1383]

[eu.et.cd.pe.da.in.AdvancedBeanInitializer] - bulk load - DONE
The actual initialization takes place in AdvancedBeanlnitializer.bulkLoadLazyBeans(BeanInitNode node). Here a strange behavior
can be observed in these special cases:

private void bulkLoadLazyBeans (node node) {
for (Class<?> clazz : node.getlazyBeans () .keySet()) {
Set<Serializable> idSet = node.getlLazyBeans () .get (clazz);

String hgl = " SELECT c¢c FROM %s as ¢ %s WHERE c.id IN (:idSet) ";
hgl = String.format (hgl, clazz.getSimpleName (), autoInit.leftJoinFetch);
// hgl = "SELECT c FROM TeamOrPersonBase as ¢ WHERE c.id IN (:idSet)"

Query query = genericDao.getHglQuery (hqgl);
query.setParameterList ("idSet", idSet);
List<Object> list = query.list();

Now the TeamOrPersonBase entities are initialized.
However, checking the parent object contained in the node object passed as parameer reveals that the 'authorship' proxy in
the object graph has not been initialized.

Preloading the reference in the RegistrationWorkingSetService.loadWorkingSetByReferencelD(Integer referencelD) method avoids
the problem (in the below code only relevant lines are shown)

Reference reference = repo.getReferenceService().find(referencelD);
repo.getReferenceService () .load(reference.getUuid());

Since this behavior is data dependent, | serialized the fully initialized registrations as loaded in the
RegistrationDaoHibernatelmpl.list(Optional<Reference> reference, Collection<RegistrationStatus> includedStatus, Integer limit,
Integer start, List<String> propertyPaths). registrations-fully-initialized.ser can be used to restore the original data by de-serializing
and persisting the objects to a cdm-database (version 4.15.0-SNAPSHOT)

try {
FileInputStream fin = new FileInputStream("registrations—-fully-initialized.ser");
ObjectInputStream oin = new ObjectInputStream(fin);
List<Registration> registrationsDeserialized = (List<Registration>) oin.readObject();
} catch (ClassNotFoundException | IOException e) {
// TODO Auto-generated catch block
e.printStackTrace () ;

NOTE: Doing the serialization in RegistrationDaoHibernatelmpl.list() also removed the problem described in here:

try f
FileOutputStream fout = new FileOutputStream("registrations-before-initialization.ser"

ObjectOutputStream oos = new ObjectOutputStream(fout);
oos.writeObject (results);

} catch (IOException e) {
// TODO Auto-generated catch block
e.printStackTrace();

defaultBeanInitializer.initializeAll (results, propertyPaths);

// initialization is incomplete

try {
FileOutputStream fout = new FileOutputStream("registrations—after-initialization.ser"

ObjectOutputStream oos = new ObjectOutputStream(fout);
oos.writeObject (results);

} catch (IOException e) {
// TODO Auto-generated catch block
e.printStackTrace () ;

// fully initialized now! the file registrations-fully-initialized.ser has been created after this
https://dev.e-taxonomy.eu/redmine/attachments/1194

Additional tasks:
® remove af4969c¢833 and test carefully!!!

Potentially duplicate tickets:

Related issues:

Related to EDIT - bug #7342: incomplete bean initialization with specific dat... Worksforme
Related to EDIT - task #7330: TitleAndNameCacheAutolnitializer misses out Ref... New
Has duplicate EDIT - bug #7511: LazylnitializationException (LIE) opening Reg... Duplicate

Associated revisions

Revision 7d60d703 - 03/27/2018 02:44 PM - Andreas Kohlbecker
ref #7331 test created and loging more details at level TRACE

Revision 1d6d9f08 - 03/27/2018 02:52 PM - Andreas Kohlbecker
ref #7331 cicrumventing the bug for RegistrationWorkingSetService.loadWorkingSetByReferencelD()

Revision beb7ef65 - 06/25/2018 12:59 PM - Andreas Kohlbecker

ref #7331 re-introducing load to cirumvent bug

Revision 637becc5 - 07/03/2018 06:12 PM - Andreas Kohlbecker

ref #7331 using load instead of find to avoid the magic bug in the AdvancedBeaninitializer
Revision af4969c8 - 06/25/2020 12:22 PM - Andreas Kohlbecker
ref #9095, ref #9096 catching LIEs at Team.members in TeamOrPersonBaseBeanProcessor to handle problems potentially originating from bug ref

#7331

Revision 927a1c72 - 06/25/2020 01:59 PM - Andreas Kohlbecker

ref #7331 restoring lost test methods comment

Revision a8905b5d - 06/25/2020 05:40 PM - Andreas Kohlbecker
reverting commit last for ref #9095, ref #9096, ref #7331 for a better solution

History

#1 - 03/27/2018 02:05 PM - Andreas Kohlbecker

- Description updated

#2 - 03/27/2018 02:10 PM - Andreas Kohlbecker
- File registrations-after-incomplete-initialization.ser added

- File registrations-before-initialization.ser added

#3 - 03/27/2018 02:16 PM - Andreas Kohlbecker
- Description updated

- Found in Version set to Release 5.0

#4 - 03/27/2018 02:25 PM - Andreas Kohlbecker

- Description updated

#5 - 03/27/2018 02:25 PM - Andreas Kohlbecker

- File deleted (registrations-before-initialization.ser)
https://dev.e-taxonomy.eu/redmine/projects/edit/repository/cdmlib/revisions/af4969c83341a4bc58f411a4c0bafb6e62e2ba9c
https://dev.e-taxonomy.eu/redmine/issues/9095
https://dev.e-taxonomy.eu/redmine/issues/9096

#6 - 03/27/2018 02:25 PM - Andreas Kohlbecker

- File deleted (registrations-after-incomplete-initialization.ser)

#7 - 03/27/2018 02:25 PM - Andreas Kohlbecker

- File registrations-fully-initialized.ser added

#8 - 03/27/2018 02:29 PM - Andreas Kohlbecker
- Description updated

#9 - 03/27/2018 02:30 PM - Andreas Kohlbecker

- Description updated

#10 - 03/27/2018 02:36 PM - Andreas Kohlbecker
- Description updated

#11 - 03/27/2018 02:38 PM - Andreas Kohlbecker

- File deleted (registrations-fully-initialized.ser)

#12 - 03/27/2018 02:39 PM - Andreas Kohlbecker
- File registrations-fully-initialized.ser added

- Description updated

#13 - 03/27/2018 02:53 PM - Andreas Kohlbecker
- % Done changed from 0 to 10

#14 - 03/27/2018 02:56 PM - Andreas Kohlbecker

| created a test to reproduce this problem in isolation 7d60d703 without success and | am avoiding the effect of this bug in

RegistrationWorkingSetService.loadWorkingSetByReferencelD() by doing an explicit load of the Reference commit:cdm-vaadin|7d60d70.

And now | am leaving this issue in favor of getting some other work done ...

#15 - 04/04/2018 02:48 PM - Katja Luther

- Related to bug #7342: incomplete bean initialization with specific data causes LIEs added

#16 - 06/06/2018 05:14 PM - Andreas Kohlbecker

- Description updated

#17 - 06/25/2018 01:12 PM - Andreas Kohlbecker
- Has duplicate bug #7511: LazylnitializationException (LIE) opening Registration Workingset Editor added

#18 - 07/10/2018 03:46 PM - Andreas Kohlbecker
- File AdvancedBeaninitializer-Breakpoints.bkpt added

Adding exported breakpoints from my eclipse which might help debugging this issue.

#19 - 06/25/2020 12:16 PM - Andreas Kohlbecker

- Related to task #7330: TitleAndNameCacheAutolnitializer misses out References added

#20 - 06/25/2020 12:24 PM - Andreas Kohlbecker

- Description updated

#21 - 06/25/2020 12:26 PM - Andreas Kohlbecker

- Description updated

#22 - 06/25/2020 12:26 PM - Andreas Kohlbecker
- Related to bug #9095: LazylnitializationException (LIE) in portal/description/distributioninfoFor/{uuid} added
https://dev.e-taxonomy.eu/redmine/projects/edit/repository/cdmlib/revisions/7d60d7030be8688c9f81cc7e5fa1624fffd4a105

#23 - 06/25/2020 12:26 PM - Andreas Kohlbecker
- Related to bug #9096: LazyInitializationException (LIE) in DescriptionElementListController.getDescriptionElementsForTaxon() added

#24 - 06/25/2020 01:06 PM - Andreas Miiller

- Description updated

#25 - 06/25/2020 05:41 PM - Andreas Kohlbecker
- Related to deleted (bug #9095: LazylnitializationException (LIE) in portal/description/distributioninfoFor/{uuid})

#26 - 06/25/2020 05:41 PM - Andreas Kohlbecker
- Related to deleted (bug #9096: LazylnitializationException (LIE) in DescriptionElementListController.getDescriptionElementsForTaxon())

Files
registrations-fully-initialized.ser 33.9KB 03/27/2018 Andreas Kohlbecker
AdvancedBeanlnitializer-Breakpoints.bkpt 9.16 KB 07/10/2018 Andreas Kohlbecker
